/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

#include <stddef.h>
#include <errno.h>
#include <string.h>
#include "nimble/hci_common.h"
#include "host/host_hci.h"
#include "host/ble_hs_test.h"
#include "testutil/testutil.h"
#include "ble_hs_test_util.h"

TEST_CASE(ble_host_hci_test_event_bad)
{
    uint8_t buf[2];
    int rc;

    /*** Invalid event code. */
    buf[0] = 0xff;
    buf[1] = 0;
    rc = host_hci_event_rx(buf);
    TEST_ASSERT(rc == BLE_HS_ENOTSUP);
}

TEST_SUITE(ble_host_hci_suite)
{
    ble_host_hci_test_event_bad();
}

int
ble_host_hci_test_all(void)
{
    ble_host_hci_suite();
    return tu_any_failed;
}
